Public Class CanvasShapes
	Inherits TcKs.MSOffice.Common.ChildObjectWrapperBase
	
	Public Sub New ( ByVal nativeObject As System.Object,  ByVal rootObject As TcKs.MSOffice.Common.RootObjectWrapperBase )
		MyBase.New ( nativeObject, rootObject )
	End Sub 
	
	Public Function Item( aIndex As System.Object ) As TcKs.MSOffice.Common.Shape
		Dim tmp_Index As System.Object = TcKs.MSOffice.Common.WrapperHelper.GetWrappedObjectIfCan( aIndex )
		Dim result As System.Object = MyBase.WrappedObject.Item( tmp_Index )
		Dim ret As New TcKs.MSOffice.Common.Shape( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Function GetEnumerator(  ) As System.Collections.IEnumerator
		Dim result As System.Object = MyBase.WrappedObject.GetEnumerator(  )
		Return result
	End Function 
	
	Public Function AddCallout( aType As TcKs.MSOffice.Common.MsoCalloutType, aLeft As System.Single, aTop As System.Single, aWidth As System.Single, aHeight As System.Single ) As TcKs.MSOffice.Common.Shape
		Dim result As System.Object = MyBase.WrappedObject.AddCallout( aType, aLeft, aTop, aWidth, aHeight )
		Dim ret As New TcKs.MSOffice.Common.Shape( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Function AddConnector( aType As TcKs.MSOffice.Common.MsoConnectorType, aBeginX As System.Single, aBeginY As System.Single, aEndX As System.Single, aEndY As System.Single ) As TcKs.MSOffice.Common.Shape
		Dim result As System.Object = MyBase.WrappedObject.AddConnector( aType, aBeginX, aBeginY, aEndX, aEndY )
		Dim ret As New TcKs.MSOffice.Common.Shape( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Function AddCurve( aSafeArrayOfPoints As System.Object ) As TcKs.MSOffice.Common.Shape
		Dim tmp_SafeArrayOfPoints As System.Object = TcKs.MSOffice.Common.WrapperHelper.GetWrappedObjectIfCan( aSafeArrayOfPoints )
		Dim result As System.Object = MyBase.WrappedObject.AddCurve( tmp_SafeArrayOfPoints )
		Dim ret As New TcKs.MSOffice.Common.Shape( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Function AddLabel( aOrientation As TcKs.MSOffice.Common.MsoTextOrientation, aLeft As System.Single, aTop As System.Single, aWidth As System.Single, aHeight As System.Single ) As TcKs.MSOffice.Common.Shape
		Dim result As System.Object = MyBase.WrappedObject.AddLabel( aOrientation, aLeft, aTop, aWidth, aHeight )
		Dim ret As New TcKs.MSOffice.Common.Shape( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Function AddLine( aBeginX As System.Single, aBeginY As System.Single, aEndX As System.Single, aEndY As System.Single ) As TcKs.MSOffice.Common.Shape
		Dim result As System.Object = MyBase.WrappedObject.AddLine( aBeginX, aBeginY, aEndX, aEndY )
		Dim ret As New TcKs.MSOffice.Common.Shape( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Function AddPicture( aFileName As System.String, aLinkToFile As TcKs.MSOffice.Common.MsoTriState, aSaveWithDocument As TcKs.MSOffice.Common.MsoTriState, aLeft As System.Single, aTop As System.Single, aWidth As System.Single, aHeight As System.Single ) As TcKs.MSOffice.Common.Shape
		Dim result As System.Object = MyBase.WrappedObject.AddPicture( aFileName, aLinkToFile, aSaveWithDocument, aLeft, aTop, aWidth, aHeight )
		Dim ret As New TcKs.MSOffice.Common.Shape( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Function AddPolyline( aSafeArrayOfPoints As System.Object ) As TcKs.MSOffice.Common.Shape
		Dim tmp_SafeArrayOfPoints As System.Object = TcKs.MSOffice.Common.WrapperHelper.GetWrappedObjectIfCan( aSafeArrayOfPoints )
		Dim result As System.Object = MyBase.WrappedObject.AddPolyline( tmp_SafeArrayOfPoints )
		Dim ret As New TcKs.MSOffice.Common.Shape( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Function AddShape( aType As TcKs.MSOffice.Common.MsoAutoShapeType, aLeft As System.Single, aTop As System.Single, aWidth As System.Single, aHeight As System.Single ) As TcKs.MSOffice.Common.Shape
		Dim result As System.Object = MyBase.WrappedObject.AddShape( aType, aLeft, aTop, aWidth, aHeight )
		Dim ret As New TcKs.MSOffice.Common.Shape( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Function AddTextEffect( aPresetTextEffect As TcKs.MSOffice.Common.MsoPresetTextEffect, aText As System.String, aFontName As System.String, aFontSize As System.Single, aFontBold As TcKs.MSOffice.Common.MsoTriState, aFontItalic As TcKs.MSOffice.Common.MsoTriState, aLeft As System.Single, aTop As System.Single ) As TcKs.MSOffice.Common.Shape
		Dim result As System.Object = MyBase.WrappedObject.AddTextEffect( aPresetTextEffect, aText, aFontName, aFontSize, aFontBold, aFontItalic, aLeft, aTop )
		Dim ret As New TcKs.MSOffice.Common.Shape( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Function AddTextbox( aOrientation As TcKs.MSOffice.Common.MsoTextOrientation, aLeft As System.Single, aTop As System.Single, aWidth As System.Single, aHeight As System.Single ) As TcKs.MSOffice.Common.Shape
		Dim result As System.Object = MyBase.WrappedObject.AddTextbox( aOrientation, aLeft, aTop, aWidth, aHeight )
		Dim ret As New TcKs.MSOffice.Common.Shape( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Function BuildFreeform( aEditingType As TcKs.MSOffice.Common.MsoEditingType, aX1 As System.Single, aY1 As System.Single ) As TcKs.MSOffice.Common.FreeformBuilder
		Dim result As System.Object = MyBase.WrappedObject.BuildFreeform( aEditingType, aX1, aY1 )
		Dim ret As New TcKs.MSOffice.Common.FreeformBuilder( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Function Range( aIndex As System.Object ) As TcKs.MSOffice.Common.ShapeRange
		Dim tmp_Index As System.Object = TcKs.MSOffice.Common.WrapperHelper.GetWrappedObjectIfCan( aIndex )
		Dim result As System.Object = MyBase.WrappedObject.Range( tmp_Index )
		Dim ret As New TcKs.MSOffice.Common.ShapeRange( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Sub SelectAll(  )
		MyBase.WrappedObject.SelectAll(  )
	End Sub 
	
	Public ReadOnly Property Application As System.Object
		Get 
			Return MyBase.WrappedObject.Application
		End Get 
	End Property 
	
	Public ReadOnly Property Creator As System.Int32
		Get 
			Return MyBase.WrappedObject.Creator
		End Get 
	End Property 
	
	Public ReadOnly Property Parent As System.Object
		Get 
			Return MyBase.WrappedObject.Parent
		End Get 
	End Property 
	
	Public ReadOnly Property Count As System.Int32
		Get 
			Return MyBase.WrappedObject.Count
		End Get 
	End Property 
	
	Public ReadOnly Property Background As TcKs.MSOffice.Common.Shape
		Get 
			Dim nativeObject As System.Object = MyBase.WrappedObject.Background
			Dim ret As New TcKs.MSOffice.Common.Shape( nativeObject, Me.RootObject )
			Return ret
		End Get 
	End Property 
	
End Class 
