Public Class DiagramNode
	Inherits TcKs.MSOffice.Common.ChildObjectWrapperBase
	
	Public Sub New ( ByVal nativeObject As System.Object,  ByVal rootObject As TcKs.MSOffice.Common.RootObjectWrapperBase )
		MyBase.New ( nativeObject, rootObject )
	End Sub 
	
	Public Function AddNode( aPos As TcKs.MSOffice.Common.MsoRelativeNodePosition, aNodeType As TcKs.MSOffice.Common.MsoDiagramNodeType ) As TcKs.MSOffice.Common.DiagramNode
		Dim result As System.Object = MyBase.WrappedObject.AddNode( aPos, aNodeType )
		Dim ret As New TcKs.MSOffice.Common.DiagramNode( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Sub Delete(  )
		MyBase.WrappedObject.Delete(  )
	End Sub 
	
	Public Sub MoveNode( aTargetNode As TcKs.MSOffice.Common.DiagramNode, aPos As TcKs.MSOffice.Common.MsoRelativeNodePosition )
		Dim tmp_TargetNode As System.Object = TcKs.MSOffice.Common.WrapperHelper.GetWrappedObjectIfCan( aTargetNode )
		MyBase.WrappedObject.MoveNode( tmp_TargetNode, aPos )
	End Sub 
	
	Public Sub ReplaceNode( aTargetNode As TcKs.MSOffice.Common.DiagramNode )
		Dim tmp_TargetNode As System.Object = TcKs.MSOffice.Common.WrapperHelper.GetWrappedObjectIfCan( aTargetNode )
		MyBase.WrappedObject.ReplaceNode( tmp_TargetNode )
	End Sub 
	
	Public Sub SwapNode( aTargetNode As TcKs.MSOffice.Common.DiagramNode, aSwapChildren As System.Boolean )
		Dim tmp_TargetNode As System.Object = TcKs.MSOffice.Common.WrapperHelper.GetWrappedObjectIfCan( aTargetNode )
		MyBase.WrappedObject.SwapNode( tmp_TargetNode, aSwapChildren )
	End Sub 
	
	Public Function CloneNode( aCopyChildren As System.Boolean, aTargetNode As TcKs.MSOffice.Common.DiagramNode, aPos As TcKs.MSOffice.Common.MsoRelativeNodePosition ) As TcKs.MSOffice.Common.DiagramNode
		Dim tmp_TargetNode As System.Object = TcKs.MSOffice.Common.WrapperHelper.GetWrappedObjectIfCan( aTargetNode )
		Dim result As System.Object = MyBase.WrappedObject.CloneNode( aCopyChildren, tmp_TargetNode, aPos )
		Dim ret As New TcKs.MSOffice.Common.DiagramNode( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Sub TransferChildren( aReceivingNode As TcKs.MSOffice.Common.DiagramNode )
		Dim tmp_ReceivingNode As System.Object = TcKs.MSOffice.Common.WrapperHelper.GetWrappedObjectIfCan( aReceivingNode )
		MyBase.WrappedObject.TransferChildren( tmp_ReceivingNode )
	End Sub 
	
	Public Function NextNode(  ) As TcKs.MSOffice.Common.DiagramNode
		Dim result As System.Object = MyBase.WrappedObject.NextNode(  )
		Dim ret As New TcKs.MSOffice.Common.DiagramNode( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Function PrevNode(  ) As TcKs.MSOffice.Common.DiagramNode
		Dim result As System.Object = MyBase.WrappedObject.PrevNode(  )
		Dim ret As New TcKs.MSOffice.Common.DiagramNode( result, Me.RootObject )
		Return ret
	End Function 
	
	Public ReadOnly Property Application As System.Object
		Get 
			Return MyBase.WrappedObject.Application
		End Get 
	End Property 
	
	Public ReadOnly Property Creator As System.Int32
		Get 
			Return MyBase.WrappedObject.Creator
		End Get 
	End Property 
	
	Public ReadOnly Property Parent As System.Object
		Get 
			Return MyBase.WrappedObject.Parent
		End Get 
	End Property 
	
	Public ReadOnly Property Children As TcKs.MSOffice.Common.DiagramNodeChildren
		Get 
			Dim nativeObject As System.Object = MyBase.WrappedObject.Children
			Dim ret As New TcKs.MSOffice.Common.DiagramNodeChildren( nativeObject, Me.RootObject )
			Return ret
		End Get 
	End Property 
	
	Public ReadOnly Property Shape As TcKs.MSOffice.Common.Shape
		Get 
			Dim nativeObject As System.Object = MyBase.WrappedObject.Shape
			Dim ret As New TcKs.MSOffice.Common.Shape( nativeObject, Me.RootObject )
			Return ret
		End Get 
	End Property 
	
	Public ReadOnly Property Root As TcKs.MSOffice.Common.DiagramNode
		Get 
			Dim nativeObject As System.Object = MyBase.WrappedObject.Root
			Dim ret As New TcKs.MSOffice.Common.DiagramNode( nativeObject, Me.RootObject )
			Return ret
		End Get 
	End Property 
	
	Public ReadOnly Property Diagram As TcKs.MSOffice.Common.IMsoDiagram
		Get 
			Dim nativeObject As System.Object = MyBase.WrappedObject.Diagram
			Dim ret As New TcKs.MSOffice.Common.IMsoDiagram( nativeObject, Me.RootObject )
			Return ret
		End Get 
	End Property 
	
	Public Property Layout As TcKs.MSOffice.Common.MsoOrgChartLayoutType
		Get 
			Return MyBase.WrappedObject.Layout
		End Get 
		Set ( ByVal Value As TcKs.MSOffice.Common.MsoOrgChartLayoutType )
			MyBase.WrappedObject.Layout = Value 
		End Set 
	End Property 
	
	Public ReadOnly Property TextShape As TcKs.MSOffice.Common.Shape
		Get 
			Dim nativeObject As System.Object = MyBase.WrappedObject.TextShape
			Dim ret As New TcKs.MSOffice.Common.Shape( nativeObject, Me.RootObject )
			Return ret
		End Get 
	End Property 
	
End Class 
