Public Class DiagramNode
	Inherits TcKs.MSOffice.Common.ChildObjectWrapperBase
	
	Friend Sub New ( ByVal nativeObject As Global.System.Object,  ByVal rootObject As Global.TcKs.MSOffice.Common.RootObjectWrapperBase )
		MyBase.New ( nativeObject, rootObject )
	End Sub 
	
	Public Function AddNode( aPos As Global.TcKs.MSOffice.Common.MsoRelativeNodePosition, aNodeType As Global.TcKs.MSOffice.Common.MsoDiagramNodeType ) As Global.TcKs.MSOffice.Word.DiagramNode
		Dim result As Global.System.Object = MyBase.WrappedObject.AddNode( aPos, aNodeType )
		Dim ret As New Global.TcKs.MSOffice.Word.DiagramNode( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Sub Delete(  )
		MyBase.WrappedObject.Delete(  )
	End Sub 
	
	Public Sub MoveNode( aTargetNode As Global.TcKs.MSOffice.Word.DiagramNode, aPos As Global.TcKs.MSOffice.Common.MsoRelativeNodePosition )
		Dim tmp_TargetNode As Global.System.Object = Global.TcKs.MSOffice.Common.WrapperHelper.GetWrappedObjectIfCan( aTargetNode )
		MyBase.WrappedObject.MoveNode( tmp_TargetNode, aPos )
	End Sub 
	
	Public Sub ReplaceNode( aTargetNode As Global.TcKs.MSOffice.Word.DiagramNode )
		Dim tmp_TargetNode As Global.System.Object = Global.TcKs.MSOffice.Common.WrapperHelper.GetWrappedObjectIfCan( aTargetNode )
		MyBase.WrappedObject.ReplaceNode( tmp_TargetNode )
	End Sub 
	
	Public Sub SwapNode( aTargetNode As Global.TcKs.MSOffice.Word.DiagramNode, aPos As Global.TcKs.MSOffice.Common.MsoRelativeNodePosition )
		Dim tmp_TargetNode As Global.System.Object = Global.TcKs.MSOffice.Common.WrapperHelper.GetWrappedObjectIfCan( aTargetNode )
		MyBase.WrappedObject.SwapNode( tmp_TargetNode, aPos )
	End Sub 
	
	Public Function CloneNode( acopyChildren As Global.System.Boolean, aTargetNode As Global.TcKs.MSOffice.Word.DiagramNode, aPos As Global.TcKs.MSOffice.Common.MsoRelativeNodePosition ) As Global.TcKs.MSOffice.Word.DiagramNode
		Dim tmp_TargetNode As Global.System.Object = Global.TcKs.MSOffice.Common.WrapperHelper.GetWrappedObjectIfCan( aTargetNode )
		Dim result As Global.System.Object = MyBase.WrappedObject.CloneNode( acopyChildren, tmp_TargetNode, aPos )
		Dim ret As New Global.TcKs.MSOffice.Word.DiagramNode( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Sub TransferChildren( aReceivingNode As Global.TcKs.MSOffice.Word.DiagramNode )
		Dim tmp_ReceivingNode As Global.System.Object = Global.TcKs.MSOffice.Common.WrapperHelper.GetWrappedObjectIfCan( aReceivingNode )
		MyBase.WrappedObject.TransferChildren( tmp_ReceivingNode )
	End Sub 
	
	Public Function NextNode(  ) As Global.TcKs.MSOffice.Word.DiagramNode
		Dim result As Global.System.Object = MyBase.WrappedObject.NextNode(  )
		Dim ret As New Global.TcKs.MSOffice.Word.DiagramNode( result, Me.RootObject )
		Return ret
	End Function 
	
	Public Function PrevNode(  ) As Global.TcKs.MSOffice.Word.DiagramNode
		Dim result As Global.System.Object = MyBase.WrappedObject.PrevNode(  )
		Dim ret As New Global.TcKs.MSOffice.Word.DiagramNode( result, Me.RootObject )
		Return ret
	End Function 
	
	Public ReadOnly Property Application As Global.TcKs.MSOffice.Word.Application
		Get 
			Dim ret As Global.TcKs.MSOffice.Word.Application =  Me.FindTopRootObject()
			Return ret
		End Get 
	End Property 
	
	Public ReadOnly Property Creator As Global.System.Int32
		Get 
			Return MyBase.WrappedObject.Creator
		End Get 
	End Property 
	
	Public ReadOnly Property Parent As Global.System.Object
		Get 
			Return MyBase.WrappedObject.Parent
		End Get 
	End Property 
	
	Public ReadOnly Property Children As Global.TcKs.MSOffice.Word.DiagramNodeChildren
		Get 
			Dim nativeObject As Global.System.Object = MyBase.WrappedObject.Children
			Dim ret As New Global.TcKs.MSOffice.Word.DiagramNodeChildren( nativeObject, Me.RootObject )
			Return ret
		End Get 
	End Property 
	
	Public ReadOnly Property Shape As Global.TcKs.MSOffice.Word.Shape
		Get 
			Dim nativeObject As Global.System.Object = MyBase.WrappedObject.Shape
			Dim ret As New Global.TcKs.MSOffice.Word.Shape( nativeObject, Me.RootObject )
			Return ret
		End Get 
	End Property 
	
	Public ReadOnly Property Root As Global.TcKs.MSOffice.Word.DiagramNode
		Get 
			Dim nativeObject As Global.System.Object = MyBase.WrappedObject.Root
			Dim ret As New Global.TcKs.MSOffice.Word.DiagramNode( nativeObject, Me.RootObject )
			Return ret
		End Get 
	End Property 
	
	Public ReadOnly Property Diagram As Global.TcKs.MSOffice.Word.Diagram
		Get 
			Dim nativeObject As Global.System.Object = MyBase.WrappedObject.Diagram
			Dim ret As New Global.TcKs.MSOffice.Word.Diagram( nativeObject, Me.RootObject )
			Return ret
		End Get 
	End Property 
	
	Public Property Layout As Global.TcKs.MSOffice.Common.MsoOrgChartLayoutType
		Get 
			Return MyBase.WrappedObject.Layout
		End Get 
		Set ( ByVal Value As Global.TcKs.MSOffice.Common.MsoOrgChartLayoutType )
			MyBase.WrappedObject.Layout = Value 
		End Set 
	End Property 
	
	Public ReadOnly Property TextShape As Global.TcKs.MSOffice.Word.Shape
		Get 
			Dim nativeObject As Global.System.Object = MyBase.WrappedObject.TextShape
			Dim ret As New Global.TcKs.MSOffice.Word.Shape( nativeObject, Me.RootObject )
			Return ret
		End Get 
	End Property 
	
End Class 
